<template>
  <div
    v-if="isOpen"
    class="border border-l-4 border-ec-neutral bg-ec-neutral-20 px-10 py-5"
    :class="{
      'border-l-ec-status-info': variant === 'information',
      'border-l-ec-status-success': variant === 'success',
      'border-l-ec-status-warning': variant === 'warning',
      'border-l-ec-status-error': variant === 'error',
    }"
  >
    <div class="flex flex-row gap-x-2">
      <div>
        <SIcon
          :name="variant"
          class="inline-block h-8 w-8"
          :class="{
            'text-ec-status-info': variant === 'information',
            'text-ec-status-success': variant === 'success',
            'text-ec-status-warning': variant === 'warning',
            'text-ec-status-error': variant === 'error',
          }"
        />
      </div>
      <div class="flex flex-grow flex-col gap-y-3">
        <p v-if="title.length" class="text-xl">{{ title }}</p>
        <div class="whitespace-pre-wrap">
          <slot />
        </div>
      </div>
      <button
        v-if="closeable"
        @click="isOpen = false"
        class="ml-auto h-10 w-10 border border-transparent text-2xl hover:border-ec-neutral"
      >
        ⛌
      </button>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, type PropType } from 'vue';
import SIcon from './SIcon.vue';

const isOpen = ref(true);

export type MessageVariant = 'information' | 'success' | 'warning' | 'error';

defineProps({
  title: {
    type: String,
    default: '',
  },
  variant: {
    type: String as PropType<MessageVariant>,
    default: 'information',
  },
  closeable: {
    type: Boolean,
    default: false,
  },
});
</script>
